# coding: utf-8

"""
    Kowabunga API documentation

    Kvm Orchestrator With A BUNch of Goods Added

    The version of the OpenAPI document: 0.52.5
    Contact: maintainers@kowabunga.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class KaktusCPU(BaseModel):
    """
    A Kaktus computing node CPU characteristics.
    """ # noqa: E501
    arch: StrictStr = Field(description="The Kaktus computing node CPU architecture.")
    model: StrictStr = Field(description="The Kaktus computing node CPU model.")
    vendor: StrictStr = Field(description="The Kaktus computing node CPU vendor.")
    sockets: StrictInt = Field(description="The Kaktus computing node CPU number of sockets.")
    cores: StrictInt = Field(description="The Kaktus computing node CPU number of cores.")
    threads: StrictInt = Field(description="The Kaktus computing node CPU number of threads.")
    __properties: ClassVar[List[str]] = ["arch", "model", "vendor", "sockets", "cores", "threads"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of KaktusCPU from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of KaktusCPU from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "arch": obj.get("arch"),
            "model": obj.get("model"),
            "vendor": obj.get("vendor"),
            "sockets": obj.get("sockets"),
            "cores": obj.get("cores"),
            "threads": obj.get("threads")
        })
        return _obj


