# coding: utf-8

"""
    Kowabunga API documentation

    Kvm Orchestrator With A BUNch of Goods Added

    The version of the OpenAPI document: 0.52.5
    Contact: maintainers@kowabunga.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from kowabunga.models.konvey_endpoint import KonveyEndpoint
from typing import Optional, Set
from typing_extensions import Self

class Konvey(BaseModel):
    """
    A Kowabunga Konvey is a layer-4 network load-balancer used to distribute service requests to associated backend instances.
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="The Konvey (Kowabunga Network Load-Balancer) ID (auto-generated).")
    name: Optional[StrictStr] = Field(default=None, description="The Konvey (Kowabunga Network Load-Balancer) name.")
    description: Optional[StrictStr] = Field(default=None, description="The Konvey (Kowabunga Network Load-Balancer) description.")
    vip: Optional[StrictStr] = Field(default=None, description="The Konvey (Kowabunga Network Load-Balancer) assigned private virtual IP address (read-only).")
    failover: Optional[StrictBool] = Field(default=True, description="Whether Konvey (Kowabunga Network Load-Balancer) must be deployed in a highly-available replicated state to support service failover.")
    endpoints: List[KonveyEndpoint] = Field(description="The Konvey (Kowabunga Network Load-Balancer) list of load-balanced endpoints.")
    __properties: ClassVar[List[str]] = ["id", "name", "description", "vip", "failover", "endpoints"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Konvey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in endpoints (list)
        _items = []
        if self.endpoints:
            for _item_endpoints in self.endpoints:
                if _item_endpoints:
                    _items.append(_item_endpoints.to_dict())
            _dict['endpoints'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Konvey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "vip": obj.get("vip"),
            "failover": obj.get("failover") if obj.get("failover") is not None else True,
            "endpoints": [KonveyEndpoint.from_dict(_item) for _item in obj["endpoints"]] if obj.get("endpoints") is not None else None
        })
        return _obj


